
####### Change the group here

group:="4";
W:=ComplexReflectionGroup(4);

#######

degrees:=ReflectionDegrees(W);
n:=W.nbGeneratingReflections;
h:=Maximum(degrees);
distRefl:=Reflections(W);
refl:=Concatenation(List(distRefl,s->List([1..Order(W,s)-1],i->s^i)));
a:=n*h-Length(refl);
p:=PrimeResidues(h);
q:=X(Cyclotomics);;q.name:="q";;q:=Mvp(q);
H:=Hecke(W,q);

Schurs:=SchurElements(H);
top:=Schurs[PositionId(W)];

Feg:=FakeDegrees(W,q);

Reflections(W);
ords:=W.OrdersGeneratingReflections;
classes:=[];
for tt in W.reflections do
	for k in [1..Order(W,tt)-1] do
		t:=tt^k;
		class:=ConjugacyClass(W,t);
		classpos:=Position(ConjugacyClasses(W),class);
		classsize:=Size(class);
		if not([classsize,classpos] in classes) then
			Add(classes,[classsize,classpos]);
		fi;
	od;
od;
Contents:=List(CharTable(W).irreducibles,chi->1/chi[1]*Sum(classes,i->i[1]*chi[i[2]]));

####### Change the location of the output file here --- use full path

PrintTo("output.txt",
group,"\n",
"n=",n,";\n",
"h=",h,";\n",
"a=",a,";\n",
"p=List",p,";\n",
"schurs=Simplify[List",Schurs,"];\n",
"top=",top,";\n",
"feg=List",Feg,";\n",
"degrees=List",String(degrees),";\n",
"contents=List",Contents,";\n");






